  {----------------------------------------------------------------------}
  { Project title:       EMF52L                                          }
  { Project description: Software debugger for C51/C52 micro controllers }
  { Unit:                EMF52L_L                                        }
  { Unit Description:    Language support unit                           }
  { Compiler:            Borland/Turbo Pascal 5.5, 6.0 or 7.0            }
  { Author:              Alexei A. Frounze (c) 2003                      }
  { Version and date:    2.30 april 2003                                 }
  { History:                                                             }
  {  2003-02-02 (feb 2)  created                                         }
  {  2003-04-06 (apr 6)  updated due to the new version, 2.30            }
  {----------------------------------------------------------------------}

  {----------------------------------------------------------------------}
                                 Unit EMF52L_L;
  {----------------------------------------------------------------------}


  {----------------------------------------------------------------------}
                                   Interface
  {----------------------------------------------------------------------}


{ Select default language if none specified }

{$IFNDEF LANG_RUSSIAN}
  {$IFNDEF LANG_ENGLISH}
    {$DEFINE LANG_ENGLISH}      { Default language if none specified }
  {$ENDIF}
{$ENDIF}


{ Support for Russian language }

{$IFDEF LANG_RUSSIAN}
Const
  { Unit EmMCS52 strings }
  MsgEmulating = ' 㫨஢... <> - ⮯. ';
  MsgMemSel : Array[0..2] of String[4] = ('','','');

  { Unit EmF52L_U strings }
  MsgCalcBase : Array[0..1] of String[6] = ('.','.  ');
  MsgCalcWinTitle = '';
  MsgCalcErorr = '訡!';

  { Primary program file EMF52L strings }
  MsgStartupWait = '...';
  MsgProgInfo = 'EMF52  2.30L - ணࠬ ⫠稪  80C51/80C52. ५ 2003.'#13#10+
                '᪨ ࠢ  㭧 ᥩ  㭧 ᠭ (c) 1994-2003'#13#10+
                '⠪⭠ ଠ: alexfru@chat.ru, alex.fru@mtu-net.ru';
  MsgShell = ' "EXIT"    ⫠稪.'#13#10;
  MsgUsage : Array[0..2] of String = (
    #13#10' ⫠稪: EMF52LR.EXE <   ࠧ ணࠬ>',
    ' ⨭ 䠩   ⥬ ,    䠩 筮 ࠧ,',
    '  ७ "LST".'#13#10);
  MsgOutOfMem : Array[0..1] of String = (
    '筮 ᢮ . ॡ ', ' ᢮  .');
  MsgBinFileNotFound : Array[0..1] of String = (
    ' 筮 ࠧ ணࠬ ', '  !');
  MsgBinFileSize : Array[0..1] of String = (
    ' 䠩 筮 ࠧ   ॢ ', ' !'#13#10);
  MsgOutErr : Array[1..2] of String[22] = (
    '  ', ' ࠭ ');
  MsgErrWinTitle = '訡';
  MsgHelpWinTitle = '';
  MsgHelpWinText : Array [1..18] of String[68] = (
  '                          稥                            ',
  'Q  - 室  ணࠬ           < -  PC               ',
  '^D - 맮 DOS                    Esc - ⠭ PC            ',
  'C  -  (⪠ .) Up,Down,PgUp,PgDn -  ப稢',
  'R  -  ॣ஢                       ⨭/ᥬ',
  'M  -               ^Home,^End -  ३  砫 ,',
  'S  - 蠣 믮          ᮮ⢥⢥,   ⨭',
  'P  - 楤୮ 믮       F2  F3 -  ᥩ   PC',
  'A  - ⨭  ⥪饣 PC         䠩  ⥭ ࠭ ࠭',
  'B  - ./  ⠭                   PC  䠩',
  '^B -   窨 ⠭     Shift+(Up,Down,PgUp,PgDn) -      ',
  'G  - 믮  . ⠭     ப⪠ ⨭  ६-',
  'N  - ./.                            PC',
  'Home  - 1- . .     F4 -  ᫥  ⥬',
  'End   - 2- . .                           ',
  '0...9 - ࠭ .     Tab - ४祭  ᭮-',
  'W     -   .       ⥫묨 ॣࠬ',
  '^PgUp,^PgDn -        ^T -  稪 横       ');
  MsgSaveMemWinTitle = '࠭  ';
  MsgLoadMemWinTitle = '  ';
  MsgCalcHelpWinText : Array [1..9] of String[68] = (
  '                          稥                            ',
  'Esc - 室         \  % - ⮪       ',
  'Delete -         _ - 饭  (.  2-)',
  'Backspace - ࠭ .                                    ',
  'H - 筠<->. ⥬   & - ࠧ來                 ',
  '+ -                       | - ࠧ來               ',
  '- - ⠭                     ^ - ࠧ來 ᪫饥   ',
  '* -                      ~ -  (..   1-) ',
  '/ -                        =  Enter -  १ ');
{$ENDIF}


{ Support for English language }

{$IFDEF LANG_ENGLISH}
Const
  { Unit EmMCS52 strings }
  MsgEmulating = ' Running...      <SPACE> - stop. ';
  MsgMemSel : Array[0..2] of String[4] = ('InEx','Intn','Extn');

  { Unit EmF52L_U strings }
  MsgCalcBase : Array[0..1] of String[6] = ('Hex   ','Dec   ');
  MsgCalcWinTitle = 'Calculator';
  MsgCalcErorr = 'Error!';

  { Primary program file EMF52L strings }
  MsgStartupWait = 'One moment';
  MsgProgInfo = 'EMF52 version 2.30L - software debugger for 80C51/80C52. April 2003.'#13#10+
                'Copyright (c) 1994,2003 by Alexei A. Frounze & Alexander W. Frounze.'#13#10+
                'Contact information: alexfru@chat.ru, alex.fru@mtu-net.ru';
  MsgShell = 'Type "EXIT" to return to the debugger.'#13#10;
  MsgUsage : Array[0..2] of String = (
    #13#10'Usage: EMF52LE.EXE <program binary image file>',
    'The listing file must have the same file name as the binary image file,',
    'but with the "LST" file name extension.'#13#10);
  MsgOutOfMem : Array[0..1] of String = (
    'Not enough free RAM. The debugger needs approx. ', ' bytes free.');
  MsgBinFileNotFound : Array[0..1] of String = (
    'The program binary image file ', ' not found!');
  MsgBinFileSize : Array[0..1] of String = (
    'The size of the binary image file is limited to ', ' bytes max!'#13#10);
  MsgOutErr : Array[1..2] of String[22] = (
    'Unable to read from   ', 'Unable to write to    ');
  MsgErrWinTitle = 'Error';
  MsgHelpWinTitle = 'Help';
  MsgHelpWinText : Array [1..18] of String[68] = (
  '                              Hot Keys                              ',
  'Q  - Quit                         < - Save PC                    ',
  '^D - DOS shell                    Esc - Restore PC                 ',
  'C  - Reset (clear internal RAM)   Up,Down,PgUp,PgDn -        Browse',
  'R  - Edit registers                             listing/disassembly',
  'M  - Edit RAM                     ^Home,^End -  Goto the beginning/',
  'S  - Trace into                                  end of the listing',
  'P  - Step over                    F2  F3 -    Save/Load RAM and PC',
  'A  - Browse at current PC                            to/from a file',
  'B  - Toggle breakpoint                                             ',
  '^B - Clear all breakpoints        Shift+(Up,Down,PgUp,PgDn) -      ',
  'G  - Run until breakpoint                       Browse listing with',
  'N  - View internal/external RAM                       PC adjustment',
  'Home  - 1st page of internal RAM  F4 - Integer calculator (Dec/Hex)',
  'End   - 2nd page of internal RAM                                   ',
  '0...9 - Pages of external RAM     Tab -     Switch between main and',
  'W     - External RAM address                   additional registers',
  '^PgUp,^PgDn - Browse RAM          ^T - Reset clock counter         ');
  MsgSaveMemWinTitle = 'Save RAM to file';
  MsgLoadMemWinTitle = 'Load RAM from file';
  MsgCalcHelpWinText : Array [1..9] of String[68] = (
  '                              Hot Keys                              ',
  'Esc - Quit the calculator         \ or % - Division remainder      ',
  'Delete - Reset the calculator     _ - Sign reversal (2''s complem.) ',
  'Backspace - Erase last digit                                       ',
  'H - Decimal<->hexadecimal system  & - Bitwise AND                  ',
  '+ - Addition                      | - Bitwise OR                   ',
  '- - Subtraction                   ^ - Bitwise exclusive OR         ',
  '* - Multiplication                ~ - NOT (e.g. 1''s complementing) ',
  '/ - Division                      = or Enter - Get the result     ');
{$ENDIF}

  {----------------------------------------------------------------------}
                                 Implementation
  {----------------------------------------------------------------------}

End.
