  {----------------------------------------------------------------------}
  { Project title:       EMF52L                                          }
  { Project description: Software debugger for C51/C52 micro controllers }
  { Unit:                EmF52L_U                                        }
  { Unit Description:    Supplementary unit (listing file & calculator)  }
  { Compiler:            Borland/Turbo Pascal 5.5, 6.0 or 7.0            }
  { Author:              Alexei A. Frounze (c) 1994...2003               }
  { Version and date:    2.2 february 2003                               }
  { History:                                                             }
  {----------------------------------------------------------------------}

  {----------------------------------------------------------------------}
                                 Unit EmF52L_U;
  {----------------------------------------------------------------------}

  {----------------------------------------------------------------------}
                                   Interface
  {----------------------------------------------------------------------}

Uses
  EMF52L_L,
  CRT;

Const
{    ப  78 ᨬ }
  BLen =  829;
{   ᬮ ⨭ }
  WH   =   14;
{  TEMP-䠩 }
  LN   = '$TEMP$.$$$';
{ 訡 }
  eOk     = 0;
  eRead   = 1;
  eWrite  = 2;

Type
  Str78 = String[78];
  FileBuf = ^Buf;
  Buf = Array [0..BLen-1] of Str78;
  TCalcScrUpdate = Procedure;

Var
  StrNum,
  BFirst,
  WFirst  : Word;
  FBuf    : FileBuf;
  FList   : Boolean;
  Error   : Integer;
  ErrName : String;

Function Valu (S : String) : Word;
Function UpStr (S : String) : String;
Procedure Color (B, T : Byte);
Procedure Window (X, Y, L, H : Byte; Name : String; B, T : Byte);
Procedure ConvertList (Name : String);
Procedure ReadBlock (FStr, CStr, NStr : Word);
Procedure NextBlock;
Procedure PrevBlock;
Procedure PositL (N : Word);
Procedure Calc (UpdateProc: TCalcScrUpdate);

  {----------------------------------------------------------------------}
                                 Implementation
  {----------------------------------------------------------------------}

Function Valu (S : String) : Word;
Var
  N : Word;
  Code : Integer;
Begin
  Val (S, N, Code);
  Valu := N
End;

Function UpStr (S : String) : String;
Var
  I  : Byte;
  St : String;
Begin
  St := S;
  For I := 1 to Length (S) do
    St[I] := UpCase (S[I]);
  UpStr := St
End;

Procedure Color (B, T : Byte);
Begin
  TextColor (T);
  TextBackGround (B)
End;

Procedure Window (X, Y, L, H : Byte; Name : String; B, T : Byte);
Var
  Min, Max : Word;
  I, J : Byte;
Begin
  Color (B, T);
  Min := WindMin;
  Max := WindMax;
  CRT.Window (X, Y, X+L-1, Y+H-1);
  ClrScr;
  CRT.Window (Lo(Min)+1, Hi(Min)+1, Lo(Max)+1, Hi(Max)+1);
  GotoXY (X+2, Y+1); Write ('');
  GotoXY (X+2, Y+H-2); Write ('');
  GotoXY (X+L-3, Y+1); Write ('');
  GotoXY (X+L-3, Y+H-2); Write ('');
  For I := X+3 to X+L-4 do
    Begin
      GotoXY (I, Y+1); Write ('');
      GotoXY (I, Y+H-2); Write ('')
    End;
  For J := Y+2 to Y+H-3 do
    Begin
      GotoXY (X+2, J); Write ('');
      GotoXY (X+L-3, J); Write ('')
    End;
  GotoXY (X+(L-Length(Name)) div 2-1, Y+1);
  Write (' '+Name+' ');
  Color (Black, Black);
  For J := Y+1 to Y+H do
    Begin
      GotoXY (X+L, J);
      Write ('')
    End;
  For I := X+2 to X+L do
    Begin
      GotoXY (I, Y+H);
      Write ('')
    End;
  Color (B, T)
End;

Procedure ConvertList (Name : String);
Var
  T : Text;
  F : File of Str78;
  S : String;
  R : Str78;
  I : Byte;
  TextBuffer : Array [0..8191] of Byte;
Label
  LoopContinue1,
  LoopBreak1;
Begin
  Assign (T, Name);
  SetTextBuf (T, TextBuffer, SizeOf(TextBuffer));
  {$I-} Reset (T); {$I+}
  If IOResult <> 0 then
    Begin
      ErrName := Name;
      Error := eRead;
      Exit
    End;
  Assign (F, LN);
  {$I-} Rewrite (F); {$I+}
  If IOResult <> 0 then
    Begin
      Close (T);
      ErrName := LN;
      Error := eWrite;
      Exit
    End;
  Repeat
LoopContinue1:
    {$I-} ReadLn (T, S); {$I+}
    If IOResult <> 0 then
      Begin
        Close (T);
        Close (F);
        ErrName := Name;
        Error := eRead;
        Exit
      End;
    If Copy (S, 1, 5) = 'Label' then {Break;} Goto LoopBreak1;
    If (Copy (S, 2, 4) = 'TASM') or
       (Copy (S, 1, 6) = 'Speech') or
       (S = '') then {Continue;} Goto LoopContinue1;
    If Length (S) > 78 then S := Copy (S, 1, 78);
    R := S;
    {$I-} Write (F, R); {$I+}
    If IOResult <> 0 then
      Begin
        Close (T);
        Close (F);
        ErrName := LN;
        Error := eWrite;
        Exit
      End;
  Until EOF (T);
LoopBreak1:
  Close (T);
  R := '';
  For I := 1 to WH-1 do
    Begin
      Write (F, R); {$I+}
      If IOResult <> 0 then
        Begin
          Close (F);
          ErrName := LN;
          Error := eWrite;
          Exit
        End
    End;
  StrNum := FileSize (F);
  Close (F)
End;

Procedure ReadBlock (FStr, CStr, NStr : Word);
Var
  J : Byte;
  F : File of Str78;
  I : Word;
Begin
  Assign (F, LN);
  {$I-} Reset (F); {$I+}
  If IOResult <> 0 then
    Begin
      ErrName := LN;
      Error := eRead;
      Exit
    End;
  {$I-} Seek (F, FStr-1); {$I+}
  If IOResult <> 0 then
    Begin
      Close (F);
      ErrName := LN;
      Error := eRead;
      Exit
    End;
  I := 0;
  While (I <> CStr) and (not EOF(F)) do
    Begin
      {$I-} Read (F, FBuf^[NStr+I]); {$I+}
      If IOResult <> 0 then
        Begin
          Close (F);
          ErrName := LN;
          Error := eRead;
          Exit
        End;
      Inc (I)
    End;
  If I <> CStr then
    For I := I to CStr do
      FBuf^[NStr+I] := '';
  Close (F)
End;

Procedure NextBlock;
Var
  I : Word;
Begin
  For I := 0 to WH-1 do
    FBuf^[I] := FBuf^[BLen-1-WH+1+I];
  ReadBlock (BFirst+BLen, BLen-WH, WH);
  If Error <> eOk then Exit;
  Inc (BFirst, BLen-WH);
  WFirst := 1
End;

Procedure PrevBlock;
Var
  I : Word;
Begin
  For I := 0 to WH-1 do
    FBuf^[BLen-1-WH+1+I] := FBuf^[I];
  ReadBlock (BFirst-BLen+WH, BLen-WH, 0);
  If Error <> eOk then Exit;
  Dec (BFirst, BLen-WH);
  WFirst := BLen-WH-1
End;

Procedure PositL (N : Word);
Var I : Word;
Begin
  If N = 0 then N := 1;
  I := ((N-1) div (BLen-WH))*(BLen-WH)+1;
  While I < BFirst do
    Begin
      PrevBlock;
      If Error <> eOk then Exit
    End;
  While I > BFirst do
    Begin
      NextBlock;
      If Error <> eOk then Exit
    End;
  WFirst := N - BFirst;
End;

Function StrToNum (S : String) : LongInt;
Var
  Code : Integer;
  N    : LongInt;
Begin
  Val (S, N, Code);
  StrToNum := N
End;

Function NumToStr (N : LongInt) : String;
Var
  S : String;
Begin
  Str (N, S);
  NumToStr := S
End;

Function DecToHex (D : LongInt) : String;
Const
  Hex : Array [0..15] of Char = ('0','1','2','3','4','5','6','7','8','9',
                                                 'A','B','C','D','E','F');
Var
  S : String;
  DD: Array[0..Sizeof(LongInt)-1] of Byte Absolute D;
  I : Byte;
  C : Char;
  F : Boolean;
Begin
  S := '';
  F := False;
  For I := Sizeof(LongInt)-1 downto 0 do Begin
    C := Hex[DD[I] shr 4];
    If (C <> '0') or F then Begin
      S := S + C;
      F := True;
    End;
    C := Hex[DD[I] and 15];
    If (C <> '0') or F then Begin
      S := S + C;
      F := True;
    End;
  End;
  If S = '' then S := '0';
  DecToHex := S
End;

Function HexToDec (H : String) : LongInt;
Var
  D : LongInt;
  DD: Array[0..Sizeof(LongInt)-1] of Byte Absolute D;
  B,
  I, J : Byte;
Begin
  D := 0;
  J := 0;
  For I := Length(H) downto 1 do Begin
    H[I] := Upcase(H[I]);
    If H[I] in ['0'..'9'] then B := Ord(H[I])-Ord('0')
    Else If H[I] in ['A'..'F'] then B := Ord(H[I])-Ord('A')+10
    Else B := 0;
    If J and 1 = 1 then B := B shl 4;
    DD[J shr 1] := DD[J shr 1] or B;
    Inc (J);
  End;

  HexToDec := D
End;

Procedure Calc (UpdateProc: TCalcScrUpdate);
Const
  DecChars : Set of Char = ['0'..'9'];
  HexChars : Set of Char = ['0'..'9', 'A'..'F'];
Type
  TCalcState = (CSEnterFirst, CSEnterSecond, CSCalc,
                CSError, CSReset, CSQuit);
  TBase = (Dec, Hex);
  TValue = Record
    Value : LongInt;
    Input : String[11];
  End;
Var
  OldState,
  State : TCalcState;
  Base : TBase;
  XVal, YVal : TValue;
  OldOperation,
  Operation : Char;

  Procedure Help;
  Var
    I : Byte;
    C : Char;
    Procedure WrSt (S : String);
    Var J : Byte;
    Begin
      Color (Cyan, Red);
      For J := 1 to Length (S) do
        Begin
          If S[J] = '-' then Color (Cyan, Black);
          Write (S[J]);
          If (S[J] = '') and (S[J+2] in [#33..#127]) then
            Color (Cyan, Red)
        End
    End;
  Begin
    Window (3, 2+4, 76, 22-9, MsgHelpWinTitle, Cyan, Black);
    GotoXY (7, 4+4);
    Write (MsgCalcHelpWinText[1]);
    For I := 2 to 9 do
      Begin
        GotoXY (7, 3+4+I);
        WrSt (MsgCalcHelpWinText[I])
      End;
    While ReadKey <> #27 do;
    Delay (100);
    While KeyPressed do C := ReadKey;
    Color (Black, Green);
    ClrScr
  End;

  Procedure WriteEverything;
  Begin
    If State = CSError then Begin
      GotoXY (31+6+1,12);
      Color (Blue, LightGreen);
      Write (MsgCalcErorr:11);
      Exit;
    End;

    GotoXY (31+0, 13);
    Color (Blue, LightGreen);
    Case Base of
      Hex:
        Write (MsgCalcBase[0]);
      Dec:
        Write (MsgCalcBase[1]);
    End;

    If (State <> CSEnterFirst) and (State <> CSEnterSecond) then
      Exit;

    Color (Blue, LightCyan);
    If State = CSEnterFirst then Begin
      GotoXY (31+6+1, 12);
      Write (' ':11);
      GotoXY (31+6+1, 13)
    End
    Else { If State = CSEnterSecond }
      GotoXY (31+6+1, 12);
    Case Base of
      Dec:
        Write (XVal.Value:11);
      Hex:
        Write (DecToHex(XVal.Value):11);
    End;

    If State = CSEnterSecond then Begin
      GotoXY (31+6+1, 13);
      Case Base of
        Dec:
          Write (YVal.Value:11);
        Hex:
          Write (DecToHex(YVal.Value):11);
      End;
    End;

    Color (Blue, LightGreen);
    GotoXY (31+6+1+11+1, 12);
    Write (Operation);
    Color (Blue, LightCyan);
  End;

  Procedure Edit;
  Var
    C : Char;
    PValue : ^TValue;
    Temp : LongInt;
    ErrCode : Integer;
  Begin
    If State = CSEnterFirst then PValue := @XVal
    Else PValue := @YVal;

    Repeat
      If KeyPressed then Begin
        C := UpCase (ReadKey);

        If C = #0 then Begin
          C := ReadKey;
          Case C of
            #83:
              Begin
                State := CSReset;
                Exit
              End;
            #59:
              Begin
                Help;
                UpdateProc;
                Window (27, 10, 28, 6, MsgCalcWinTitle, Blue, LightCyan);
                WriteEverything;
              End
          End;
          C := ' '
        End;

        If (State = CSEnterFirst) or (State = CSEnterSecond) then Begin
          If C = '_' then
            Begin
              Case Base of
                Dec:
                  Begin
                    PValue^.Value := StrToNum (PValue^.Input);
                    PValue^.Value := - PValue^.Value;
                    PValue^.Input := NumToStr (PValue^.Value)
                  End;
                Hex:
                  Begin
                    PValue^.Value := HexToDec (PValue^.Input);
                    PValue^.Value := - PValue^.Value;
                    PValue^.Input := DecToHex (PValue^.Value)
                  End;
              End;
            End;

          If C = '~' then
            Begin
              Case Base of
                Dec:
                  Begin
                    PValue^.Value := StrToNum (PValue^.Input);
                    PValue^.Value := not PValue^.Value;
                    PValue^.Input := NumToStr (PValue^.Value)
                  End;
                Hex:
                  Begin
                    PValue^.Value := HexToDec (PValue^.Input);
                    PValue^.Value := not PValue^.Value;
                    PValue^.Input := DecToHex (PValue^.Value)
                  End;
              End;
            End;

          If C = 'H' then
            Begin
              Case Base of
                Dec:
                  Begin
                    PValue^.Value := StrToNum (PValue^.Input);
                    PValue^.Input := DecToHex (PValue^.Value);
                    Base := Hex;
                  End;
                Hex:
                  Begin
                    PValue^.Value := HexToDec (PValue^.Input);
                    PValue^.Input := NumToStr (PValue^.Value);
                    Base := Dec;
                  End;
              End;
            End;

          If (C = #8) then Begin
            Case Base of
              Hex, Dec:
                Begin
                  If Length(PValue^.Input) > 1 then
                    PValue^.Input :=
                      Copy (PValue^.Input, 1, Length(PValue^.Input)-1)
                  Else
                    PValue^.Input := '0';
                End;
            End;
            If PValue^.Input = '-' then
              PValue^.Input := '0';
          End;

          If (Base = Hex) and (C in HexChars) and
            (Length(PValue^.Input) < 8) then Begin
            If PValue^.Input = '0' then
              PValue^.Input := C
            Else
              PValue^.Input := PValue^.Input + C;
          End;

          If (Base = Dec) and (C in DecChars) then Begin
            If ((PValue^.Input[1] = '-') and (Length(PValue^.Input) < 11)) or
               ((PValue^.Input[1] <> '-') and (Length(PValue^.Input) < 10)) then Begin
              Val (PValue^.Input + C, Temp, ErrCode);
              If ErrCode = 0 then Begin
                If PValue^.Input = '0' then
                  PValue^.Input := C
                Else
                  PValue^.Input := PValue^.Input + C;
              End;
            End;
          End;

          Case Base of
            Dec:
              PValue^.Value := StrToNum (PValue^.Input);
            Hex:
              PValue^.Value := HexToDec (PValue^.Input);
          End;

          Case C of
            '+','-','*','/','\','%','&','|','^':
              Begin
                Operation := C;
                WriteEverything;
                State := CSCalc;
                Exit
              End;
            '=',#13:
              Begin
                If State = CSEnterSecond then Begin
                  Operation := C;
                  WriteEverything;
                  State := CSCalc;
                  Exit
                End;
              End;
            #27:
              Begin
                State := CSQuit;
                Exit;
              End;
          End;

        End;

        WriteEverything;

      End;
    Until False;
  End;

  Function Calcul (Var ResVar: TValue; Operation: Char): Boolean;
  Var
    Res: Boolean;
    ZVal: TValue;
  Begin
    ZVal.Value := 0;
    Res := True;
    Case Operation of
      '+': ZVal.Value := XVal.Value + YVal.Value;
      '-': ZVal.Value := XVal.Value - YVal.Value;
      '&': ZVal.Value := XVal.Value AND YVal.Value;
      '|': ZVal.Value := XVal.Value OR YVal.Value;
      '^': ZVal.Value := XVal.Value XOR YVal.Value;
      '*': ZVal.Value := XVal.Value * YVal.Value;
      '/':
           If YVal.Value = 0 then Res := False
           Else ZVal.Value := XVal.Value div YVal.Value;
      '\','%':
           If YVal.Value = 0 then Res := False
           Else ZVal.Value := XVal.Value mod YVal.Value;
    End;
    Case Base of
      Dec:
        ZVal.Input := NumToStr (ZVal.Value);
      Hex:
        ZVal.Input := DecToHex (ZVal.Value);
    End;
    ResVar := ZVal;
    Calcul := Res;
  End;

Label
  LB, LE;

Begin
LB:
  OldState := CSReset;
  State := CSEnterFirst;
  Base := Dec;

  XVal.Value := 0;
  XVal.Input := '0';
  YVal := XVal;

  OldOperation := ' ';
  Operation := ' ';

  Window (27, 10, 28, 6, MsgCalcWinTitle, Blue, LightCyan);

  Repeat

    OldState := State;
    OldOperation := Operation;

    WriteEverything;
    Edit;

    If State = CSReset then Goto LB;

    If State = CSCalc then Begin
      If Operation in ['+','-','*','/','\','%','&','|','^'] then Begin
        If OldState = CSEnterSecond then Begin
          State := CSEnterSecond;
          If not Calcul (XVal, OldOperation) then State := CSError;
          YVal.Value := 0;
          YVal.Input := '0';
        End;
      End;
      If Operation in ['=',#13] then Begin
        If OldState = CSEnterSecond then Begin
          State := CSEnterFirst;
          If not Calcul (XVal, OldOperation) then State := CSError;
          YVal.Value := 0;
          YVal.Input := '0';
          Operation := ' ';
        End;
      End;
      If OldState = CSEnterFirst then Begin
        State := CSEnterSecond;
      End;
    End

  Until State = CSQuit;

LE:
  Color (Black, Green)
End;

Begin
  Error := eOk;
  ErrName := ''
End.
