  {----------------------------------------------------------------------}
  { Project title:       EMF52L                                          }
  { Project description: Software debugger for C51/C52 micro controllers }
  { Unit:                S_INPUT                                         }
  { Unit Description:    Unit for entering/editing text strings          }
  { Author:              Alexei A. Frounze (c) 1994...2003               }
  { Version and date:    1.0 1994                                        }
  { History:                                                             }
  {----------------------------------------------------------------------}

  {----------------------------------------------------------------------}
                                 Unit S_INPUT;
  {----------------------------------------------------------------------}


  {----------------------------------------------------------------------}
                                   Interface
  {----------------------------------------------------------------------}

  Var
    InputCase : Byte;
  {0 -  , 1 - 孨 ॣ, 2 -  ॣ}

  Procedure ReadS (Var S : String; Len : Byte);
  { 楤, 筠 楤 ReadLn   SYSTEM.
   室: ப ६   १ 
  ᫮ - ᨬ쭠   ப }

  Procedure ReadSK (Var S : String; N : Byte);
  {    楤. ⫨ :  ।஢
  㦥  ப, ७ ।஢ (Left, Right,
  Del, BackSpace, Ins)}

  Procedure ReadSKT (Var S : String; N : Byte; Var Status : Byte);
  {  楤 筠 ।饩.  Status 頥 ᥢ-
   , ன 뫮 祭 ।஢ ப.
  0 ᮮ⢥  Enter,
  1 - Esc,
  2 - Tab,
  3 - Shift+Tab
  4 - Up,
  5 - Down.}

  {----------------------------------------------------------------------}
                                 Implementation
  {----------------------------------------------------------------------}

  Uses
    CRT,
    ProfText;

  Function LCase (C : Char) : Char;
    Function DnCase (C : Char) : Char;
    Begin
      If C in ['A'..'Z'] then DnCase := Chr (Ord (C) - 32)
      Else DnCase := C
    End;
  Begin
    If InputCase = 0 then
      LCase := C
    Else If InputCase = 1 then
      LCase := UpCase (C)
    Else
      LCase := DnCase (C)
  End;

  Function ReadKey : Char;
  Begin
    ReadKey := LCase (CRT.ReadKey)
  End;

  Procedure ReadS (Var S : String; Len : Byte);
  Var
    C : Char;
    X,
    Y : Byte;
  Begin
    S := '';
    C := #$FF;
    X := WhereX;
    Y := WhereY;
    While (C <> #13) and (C <> #27) do
      If KeyPressed then
        Begin
          C := ReadKey;
          Case Ord (C) of
            0       :
              Begin
                C := ReadKey;
                C := #$FF
              End;
            8       : If Length (S) > 0 then
              Begin
                S := Copy (S, 1, Length (S) - 1);
                GotoXY (X, Y); Write (S+' '); GotoXY (X + Length(S), Y)
              End;
            27      : S := '';
            32..254 : If Length(S) < Len then
              Begin
                S := S + C;
                GotoXY (X, Y); Write (S)
              End
          End
        End
  End;

  Procedure ReadSK (Var S : String; N : Byte);
  Var
    C : Char;
    Up, Dn,
    X, Y,
    P : Byte;
    I : Boolean;
  Label
    LoopBreak1,
    L1,
    L2,
    L3;
  Begin
    GetCursorLines (Up, Dn);
    P := 1+Length(S);
    I := True;
    C := #$FF;
    X := WhereX; Y := WhereY;
    Write (S);
    Repeat
      If KeyPressed then C := ReadKey;
      If (C = #27) or (C = #13) then {Break;} Goto LoopBreak1;
      If Ord (C) in [32..254] then
        Begin
          If I and (Length (S) < N) then
            Begin
              If P = 1 then S := C+S;
              If P = 1+Length(S) then Begin S := S+C; Goto L1 End;
              If (P <> 1) and (P <> 1+Length(S)) then
                S := Copy (S, 1, P-1)+C+Copy (S, P, Length (S)-P+1);
              L1:
              Inc (P)
            End;
          If (not I) and (P <= Length (S)) then
            Begin
              S[P] := C;
              Inc (P)
            End;
          GotoXY (X, Y);
          Write (S);
          GotoXY (X+P-1, Y)
        End;
      If (C = #8) and (P > 1) then
        Begin
          If P = 1+Length(S) then
            Begin
              If Length (S) = 1 then S := ''
              Else S := Copy (S, 1, Length(S)-1);
              Goto L2
            End;
          If P = 2 then S := Copy (S, 2, Length(S)-1);
          If (P <> 2) and (P <> 1+Length(S)) then
            S := Copy (S, 1, P-2) + Copy (S, P, Length(S)-P+1);
          L2:
          Dec (P);
          GotoXY (X, Y);
          Write (S);
          While WhereX < X+N do Write (' ');
          GotoXY (X+P-1, Y)
        End;
      If C = #0 then
        Begin
          C := ReadKey;
          Case C of
            #71:P := 1;
            #79:P := 1+Length(S);
            #75:If P > 1 then Dec (P);
            #77:If P <= Length (S) then Inc (P);
            #83:If (S <> '') and (P <= Length (S)) then
              Begin
                If P = 1 then
                  Begin
                    If Length (S) = 1 then S := ''
                    Else S := Copy (S, 2, Length(S)-1);
                    Goto L3
                  End;
                If P = Length (S) then
                  S := Copy (S, 1, Length(S)-1);
                If (P <> 1) and (P <> Length(S)) then
                  S := Copy (S, 1, P-1) + Copy (S, P+1, Length(S)-P);
                L3:
              End;
            #82:
                Begin
                  I := not I;
                  If I then CursorOn (Up, Dn)
                  Else CursorOn (0, Dn)
                End;
          End;
          GotoXY (X, Y);
          Write (S);
          While WhereX < X+N do Write (' ');
          GotoXY (X+P-1, Y)
        End;
      C := #$FF
    Until False;
  LoopBreak1:
    CursorOn (Up, Dn);
    If C = #27 then S := ''
  End;

  Procedure ReadSKT (Var S : String; N : Byte; Var Status : Byte);
  Var
    C : Char;
    Up, Dn,
    X, Y,
    P : Byte;
    I : Boolean;
  Label
    LoopBreak1,
    L1,
    L2,
    L3;
  Begin
    GetCursorLines (Up, Dn);
    P := 1+Length(S);
    I := True;
    C := #$FF;
    X := WhereX; Y := WhereY;
    Write (S);
    Repeat
      If KeyPressed then C := ReadKey;
      If (C = #27) or (C = #13) or (C = #09) then {Break;} Goto LoopBreak1;
      If Ord (C) in [32..254] then
        Begin
          If I and (Length (S) < N) then
            Begin
              If P = 1 then S := C+S;
              If P = 1+Length(S) then Begin S := S+C; Goto L1 End;
              If (P <> 1) and (P <> 1+Length(S)) then
                S := Copy (S, 1, P-1)+C+Copy (S, P, Length (S)-P+1);
              L1:
              Inc (P)
            End;
          If (not I) and (P <= Length (S)) then
            Begin
              S[P] := C;
              Inc (P)
            End;
          GotoXY (X, Y);
          Write (S);
          GotoXY (X+P-1, Y)
        End;
      If (C = #8) and (P > 1) then
        Begin
          If P = 1+Length(S) then
            Begin
              If Length (S) = 1 then S := ''
              Else S := Copy (S, 1, Length(S)-1);
              Goto L2
            End;
          If P = 2 then S := Copy (S, 2, Length(S)-1);
          If (P <> 2) and (P <> 1+Length(S)) then
            S := Copy (S, 1, P-2) + Copy (S, P, Length(S)-P+1);
          L2:
          Dec (P);
          GotoXY (X, Y);
          Write (S);
          While WhereX < X+N do Write (' ');
          GotoXY (X+P-1, Y)
        End;
      If C = #0 then
        Begin
          C := ReadKey;
          Case C of
            #15:
              Begin
                C := #03;
                {Break;} Goto LoopBreak1;
              End;
            #72:
              Begin
                C := #01;
                {Break;} Goto LoopBreak1;
              End;
            #80:
              Begin
                C := #02;
                {Break;} Goto LoopBreak1;
              End;
            #71:P := 1;
            #79:P := 1+Length(S);
            #75:If P > 1 then Dec (P);
            #77:If P <= Length (S) then Inc (P);
            #83:If (S <> '') and (P <= Length (S)) then
              Begin
                If P = 1 then
                  Begin
                    If Length (S) = 1 then S := ''
                    Else S := Copy (S, 2, Length(S)-1);
                    Goto L3
                  End;
                If P = Length (S) then
                  S := Copy (S, 1, Length(S)-1);
                If (P <> 1) and (P <> Length(S)) then
                  S := Copy (S, 1, P-1) + Copy (S, P+1, Length(S)-P);
                L3:
              End;
            #82:
                Begin
                  I := not I;
                  If I then CursorOn (Up, Dn)
                  Else CursorOn (0, Dn)
                End;
          End;
          GotoXY (X, Y);
          Write (S);
          While WhereX < X+N do Write (' ');
          GotoXY (X+P-1, Y)
        End;
      C := #$FF
    Until False;
  LoopBreak1:
    CursorOn (Up, Dn);
    Case C of
      #13 : Status := 0;
      #27 : Status := 1;
      #09 : Status := 2;
      #03 : Status := 3;
      #01 : Status := 4;
      #02 : Status := 5
    End
  End;

Begin
  InputCase := 0
End.
