IE      .EQU    0A8H
SCON    .EQU    098H
SBUF    .EQU    099H
TI      .EQU    099H
RI      .EQU    098H
TMOD    .EQU    089H
TL1     .EQU    08BH
TH1     .EQU    08DH
ET1     .EQU    0ABH
TR1     .EQU    08EH
PCON    .EQU    087H
REL96   .EQU    0FDH

P3.0    .EQU    0B0H
P3.1    .EQU    0B1H
P3.2    .EQU    0B2H
P3.3    .EQU    0B3H
P3.4    .EQU    0B4H
P3.5    .EQU    0B5H
P3.6    .EQU    0B6H
P3.7    .EQU    0B7H

SCLK    .EQU    P3.4
CS      .EQU    P3.5
DOUT    .EQU    P3.6

NUL     .EQU    0
ACK     .EQU    6
XON     .EQU    17
XOFF    .EQU    19
NAK     .EQU    21

PHWAIT  .EQU    0
PHREADY .EQU    1
PHSEND  .EQU    2
PHSENT  .EQU    3

.ORG    0
START:  MOV     IE, #0
        MOV     TMOD, #20H
        MOV     TH1, #REL96
        MOV     TL1, #REL96
        ANL     PCON, #7FH
        CLR     ET1
        MOV     SCON, #50H
        SETB    TR1

        MOV     R7, #PHWAIT     ;PHASE
CYCLE:
        JB      RI, GOT_CHAR
        AJMP    NO_CHAR
GOT_CHAR:
        MOV     A, SBUF
        CLR     RI
        CJNE    A, #NUL, CASE
        MOV     A, #ACK
        ACALL   PUTCH
        MOV     R7, #PHREADY
        AJMP    CYCLE           ;INITIALIZED
CASE:
        CJNE    R7, #PHWAIT, CASE2
        MOV     A, #NAK
        ACALL   PUTCH
        AJMP    ENDCASE         ;ERROR
CASE2:
        CJNE    R7, #PHREADY, CASE3
        CJNE    A, #XON, CASE2E
LNEW:
        ACALL   GET_VOLT
;        MOV     R3, #0FH
;        MOV     R2, #0FFH

        MOV     DPTR, #HEXTAB
        MOV     R1, #10
        MOV     A, R3
        ANL     A, #0FH
        MOVC    A, @A+DPTR
        MOV     @R1, A
        INC     R1
        MOV     A, R2
        SWAP    A
        ANL     A, #0FH
        MOVC    A, @A+DPTR
        MOV     @R1, A
        INC     R1
        MOV     A, R2
        ANL     A, #0FH
        MOVC    A, @A+DPTR
        MOV     @R1, A
LOLD:
        MOV     R7, #PHSEND
        MOV     R1, #10         ;INDEX=0 (FOR THE HEX VALUE)
        AJMP    ENDCASE         ;GOT REQUEST TO SEND, SENDING
CASE2E:
        MOV     A, #NAK
        ACALL   PUTCH
        AJMP    ENDCASE         ;ERROR
CASE3:
        CJNE    R7, #PHSEND, CASE4
        MOV     A, #NAK
        ACALL   PUTCH
        AJMP    ENDCASE         ;ERROR
CASE4:
        CJNE    R7, #PHSENT, ENDCASE
        CJNE    A, #XON, CASE41
        AJMP    LNEW            ;"MORE VALUES NEEDED" REQUEST
CASE41:
        CJNE    A, #XOFF, CASE42
        MOV     R7, #PHREADY
        AJMP    ENDCASE         ;VALUE SENT SUCCESSFULY
CASE42:
        CJNE    A, #NAK, CASE4E
        AJMP    LOLD            ;"REPEAT" REQUEST
CASE4E:
        MOV     A, #NAK
        ACALL   PUTCH
        AJMP    ENDCASE         ;ERROR
ENDCASE:
        AJMP    ENDCYC
NO_CHAR:
        CJNE    R7, #PHSEND, ENDCYC
;        MOV     A, #'F'
        MOV     A, @R1
        ACALL   PUTCH           ;INDEXED CHARACTER SENT
        INC     R1              ;NEXT INDEX
        CJNE    R1, #13, ENDCYC
        MOV     R7, #PHSENT     ;VALUE SENT
ENDCYC:
        AJMP    CYCLE

;---------------------  -----------------------

PUTCH:  MOV     SBUF, A
        JNB     TI, $
        CLR     TI
        RET

PUTSTR: CLR     A
        MOVC    A, @A+DPTR
        JZ      PUTSTR_E
        ACALL   PUTCH
        INC     DPTR
        SJMP    PUTSTR
PUTSTR_E:RET

GETCH:  JNB     RI, $
        MOV     A, SBUF
        CLR     RI
        RET

;-----    MAX 1241 (12-bit serial ADC) -----
GET_VOLT:
        SETB    DOUT            ;    ADC
        SETB    CS              ;   ADC
        CLR     SCLK            ;   ADC

        CLR     CS              ;    

        MUL     AB              ;4 MKC HA 12 MHZ \
        MUL     AB              ;4 MKC            |
        MUL     AB              ;4 MKC            }   
        MUL     AB              ;4 MKC           /
        MOV     R0, #12         ; 12 
GET_VC:
        SETB    SCLK            ;\
        NOP                     ; |
        NOP                     ; |
        CLR     SCLK            ; }     
        NOP                     ; |
        NOP                     ;/
        MOV     C, DOUT         ; 
        MOV     A, R2           ;\
        RLC     A               ; |
        MOV     R2, A           ; |
        MOV     A, R3           ; }      - R3R2
        RLC     A               ; |
        MOV     R3, A           ;/
        DJNZ    R0, GET_VC      ;
        ANL     A, #0FH
        MOV     R3, A           ;   R3R2

        SETB    CS              ;    ( =0)
        MUL     AB              ;4 MKC HA 12 MHZ \
        MUL     AB              ;4 MKC            |
        MUL     AB              ;4 MKC            |
        MUL     AB              ;4 MKC            } MIN   .
        MUL     AB              ;4 MKC            |
        MUL     AB              ;4 MKC           /
        RET
;-----     MAX 1241 (12-bit serial ADC) -----

;-----   -----
HEXTAB  .TEXT   "0123456789ABCDEF"

        .ORG    4096

.END
