Program SerCtrl2;

Uses
  CRT, DOS, Objects, Drivers, Views, App, Menus, Dialogs, StdDlg, MsgBox,
  Validate, Memory, FW, Parsing, KeyPres2;

Const
  Bits_5      =    0;
  Bits_6      =    1;
  Bits_7      =    2;
  Bits_8      =    3;
  Stops_1     =    0;
  Stops_2     =    4;
  Parity_No   =    0;
  Parity_Even =  $18;
  Parity_Odd  =    8;

  IO_Reg  = 0;
  Lo_Div  = 0;
  Hi_Div  = 1;
  Int_Reg = 1;
  Int_Id  = 2;
  Control = 3;
  Modem   = 4;
  Status  = 5;
  MStatus = 6;

  NUL  = ^@;
  ACK  = ^F;
  XON  = ^Q;
  XOFF = ^S;
  NAK  = ^U;
  ESC  = ^[;

  NameCFG     = 'SERCTRL2.CFG';
  NameData    = 'SERCTRL2.DAT';
  cmSaveCFG   = 100;
  cmAbout     = 101;
  cmSetIface  = 102;
  cmSetGeneral= 103;
  cmSetPort   = 104;
  cmSetPrnCmd = 105;
  cmView      = 106;
  cmClear     = 107;
  cmPrint     = 108;
  cmGetOne    = 109;
  cmGetSeries = 110;
  cmStop      = 111;

Type
  TConfig = Record
    ComNo : Byte;
    BaudRate : LongInt;
    ComputeTime,
    SendCharTime : Word;
    Title : String[30];
    Expression : String;
    Evaluate,
    Save : Boolean;
    LimitType : Byte;   { 0-no limit; 1-count limit; 2-time limit }
    MaxCount,
    MaxTime,                                    { secs }
    TimeQuant : LongInt;                        { ms }
    PrnCmd : String;
  End;

  PCtrlDialog = ^TCtrlDialog;
  TCtrlDialog = Object (TDialog)
    PSTS, PSTV, PSTEV : PStaticText;
    Constructor Init (aTitle : String);
    Procedure Update (Status : Byte; Value : Word);
  End;

  TCtrlApp = Object (TApplication)
    Base : Word;
    ComputeLimit,
    SendCharLimit : Word;
    CtrlDialog : PCtrlDialog;
    Constructor Init;
    Procedure InitMenuBar; Virtual;
    Procedure InitStatusLine; Virtual;
    Procedure HandleEvent (Var Event : TEvent); Virtual;
    Procedure LoadCFG;
    Procedure SaveCFG;
    Procedure About;
    Procedure SetIface;
    Procedure SetGeneral;
    Procedure SetPort;
    Procedure SetPrnCmd;
    Procedure CreateDataFile;
    Procedure OutOfMemory; Virtual;
    Procedure ViewDataFile;
    Procedure ClearDataFile;
    Procedure OpenComPort;
    Procedure CloseComPort;
    Procedure SendChar (Value : Char);
    Function ReceiveChar (Var Value : Char) : Boolean;
    Function Ticks : LongInt;
    Function Initialize : Boolean;
    Function GetValue (Var Value : Word) : Boolean;
    Procedure GetOne;
    Procedure GetSeries;
    Procedure Print;
  End;

Var
  CFG : TConfig;
  Bases : Array [1..4] of Word;
  EValueStr : String;

Constructor TCtrlDialog.Init;
Var
  R : TRect;
Begin
  R.Assign (0, 0, 40, 9);
  Inherited Init (R, aTitle);
  Options := Options or ofCentered;
  Flags := Flags and not wfClose;

  R.Assign (14, 2, 21, 3);
  Insert (New (PStaticText, Init (R, 'Status:')));
  R.Assign (22, 2, 25, 3);
  PSTS := New (PStaticText, Init (R, #7#7'S'));         { "IES" }
  Insert (PSTS);

  R.Assign (14, 3, 20, 4);
  Insert (New (PStaticText, Init (R, 'Value:')));
  R.Assign (21, 3, 25, 4);
  PSTV := New (PStaticText, Init (R, '    '));          { "4095" }
  Insert (PSTV);

  R.Assign (10, 4, 20, 5);
  Insert (New (PStaticText, Init (R, 'Evaluated:')));
  R.Assign (21, 4, 31, 5);
  PSTEV := New (PStaticText, Init (R, '          '));   { "-9999.9999" }
  Insert (PSTEV);

  R.Assign (2, 6, 11, 8);
  Insert (New (PButton, Init (R, 'Get ~1~', cmGetOne, bfNormal)));
  R.Assign (12, 6, 26, 8);
  Insert (New (PButton, Init (R, 'Get se~r~ies', cmGetSeries, bfNormal)));
  R.Assign (27, 6, 37, 8);
  Insert (New (PButton, Init (R, '~S~top', cmStop, bfNormal)));
  SelectNext (False)
End;

Procedure TCtrlDialog.Update;
Var
  S : String;
  EValue : Real;
Begin
  S := #7#7#7;
  If Status and 1 = 1 then S[3] := 'S';         { Stopped }
  If Status and 2 = 2 then S[2] := 'E';         { Error }
  If Status and 4 = 4 then S[1] := 'I';         { Initializing }
  PSTS^.Text^ := S;
  If Status and 6 = 0 then Begin
    Str (Value, S);
    PSTV^.Text^ := S;
    EValueStr := '';
    If CFG.Evaluate then
      If Parse (CFG.Expression, Value, EValue) = 0 then Begin
        Str (EValue:10:3, EValueStr);
        S := EValueStr
      End
      Else
        S := 'Error';
    PSTEV^.Text^ := S
  End;
  PSTS^.DrawView;
  PSTV^.DrawView;
  PSTEV^.DrawView
End;

Constructor TCtrlApp.Init;
Begin
  Inherited Init;
  LoadCFG;
  CreateDataFile;
  Move (Ptr(Seg0040,0)^, Bases, 4*2);
  CtrlDialog := New (PCtrlDialog, Init (CFG.Title));
  DeskTop^.Insert (CtrlDialog)
End;

Procedure TCtrlApp.InitMenuBar;
Var
  R : TRect;
Begin
  GetExtent (R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New (PMenuBar, Init (R, NewMenu (
    NewSubMenu ('~F~ile', hcNoContext, NewMenu (
      NewItem ('~V~iew data file', 'F3', kbF3, cmView, hcNoContext,
      NewItem ('~C~lear data file', 'Del', kbDel, cmClear, hcNoContext,
      NewItem ('~P~rint data file', '', kbNoKey, cmPrint, hcNoContext,
      NewLine (
      NewItem ('E~x~it', 'Alt+X', kbAltX, cmQuit, hcNoContext,
    Nil)))))),
    NewSubMenu ('~O~ptions', hcNoContext, NewMenu (
      NewItem ('~I~nterface settings...', '', kbNoKey, cmSetIface, hcNoContext,
      NewItem ('~G~eneral settings...', '', kbNoKey, cmSetGeneral, hcNoContext,
      NewItem ('~P~ort settings...', '', kbNoKey, cmSetPort, hcNoContext,
      NewItem ('Print ~c~ommand...', '', kbNoKey, cmSetPrnCmd, hcNoContext,
      NewLine (
      NewItem ('~S~ave options', '', kbNoKey, cmSaveCFG, hcNoContext,
    Nil))))))),
    NewSubMenu('~W~indows', hcNoContext, NewMenu(
      NewItem('~N~ext', 'F6', kbF6, cmNext, hcNoContext,
      NewItem('~P~revious', 'Shift+F6', kbShiftF6, cmPrev, hcNoContext,
      NewItem('~C~lose', 'Alt+F3', kbAltF3, cmClose, hcNoContext,
    Nil)))),
      NewSubMenu ('~H~elp', hcNoContext, NewMenu (
      NewItem ('~A~bout...', 'F1', kbF1, cmAbout, hcNoContext,
    Nil)),
  Nil)))))))
End;

Procedure TCtrlApp.InitStatusLine;
Var
  R: TRect;
Begin
  GetExtent (R);
  R.A.Y := R.B.Y - 1;
  New (StatusLine, Init (R,
    NewStatusDef (0, $FFFF,
      NewStatusKey ('', kbF10, cmMenu,
      NewStatusKey ('~Alt+X~ Exit', kbAltX, cmQuit,
      Nil)),
    Nil)))
End;

Procedure TCtrlApp.HandleEvent;
Begin
  Inherited HandleEvent (Event);
  If Event.What = evCommand then Begin
    Case Event.Command of
      cmAbout     : About;
      cmSaveCFG   : SaveCFG;
      cmSetIface  : SetIface;
      cmSetGeneral: SetGeneral;
      cmSetPort   : SetPort;
      cmSetPrnCmd : SetPrnCmd;
      cmView      : ViewDataFile;
      cmClear     : ClearDataFile;
      cmGetOne    : GetOne;
      cmGetSeries : GetSeries;
      cmStop      : ;
      cmPrint     : Print;
    End;
    ClearEvent (Event)
  End
End;

Procedure TCtrlApp.LoadCFG;
Var
  F : File of TConfig;
  Err : Boolean;
Label
  LErr;
Begin
  {$I-}
  Assign (F, NameCFG);
  Reset (F);
  Err := IOResult <> 0;
  If Err then Goto LErr;
  Read (F, CFG);
  Err := IOResult <> 0;
  If Err then Goto LErr;
  Close (F);
  {$I+}
  Exit;
LErr:
  MessageBox (^M^C'Couldn''t load configuration file'^M^C+NameCFG, Nil,
              mfError + mfOkButton);
  With CFG do Begin
    ComNo := 2;
    BaudRate := 9600;
    ComputeTime := 1000;
    SendCharTime := 100;
    Title := 'The x-meter';
    Expression := 'x';
    Evaluate := True;
    Save := True;
    LimitType := 2;           { time limit }
    MaxCount := 100;
    MaxTime := 60;            { secs }
    TimeQuant := 500;         { ms }
    PrnCmd := 'COPY '+NameData+' PRN'
  End
End;

Procedure TCtrlApp.SaveCFG;
Var
  F : File of TConfig;
  Err : Boolean;
Label
  LErr;
Begin
  {$I-}
  Assign (F, NameCFG);
  Rewrite (F);
  Err := IOResult <> 0;
  If Err then Goto LErr;
  Write (F, CFG);
  Err := IOResult <> 0;
  If Err then Goto LErr;
  Close (F);
  {$I+}
  Exit;
LErr:
  MessageBox (^M^C'Couldn''t save configuration file'^M^C+NameCFG, Nil,
              mfError + mfOkButton)
End;

Procedure TCtrlApp.SetIface;
Type
  TData = Record
    Title : String[30];
  End;
Label LEnd;
Var
  Data : TData;
  R : TRect;
  PD : PDialog;
  PIL : PInputLine;
Begin
  Data.Title := CFG.Title;

  R.Assign (0, 0, 42, 8);
  PD := New (PDialog, Init (R, 'Interface settings'));
  With PD^ do Begin
    Options := Options or ofCentered;

    R.Assign (3, 3, 39, 4);
    PIL := New (PInputLine, Init (R, 30));
    Insert (PIL);
    R.Assign (2, 2, 21, 3);
    Insert (New (PLabel, Init (R, 'Main window title', PIL)));

    R.Assign (10, 5, 20, 7);
    Insert (New (PButton, Init (R, 'O~k~', cmOk, bfDefault)));
    R.Assign (21, 5, 33, 7);
    Insert (New (PButton, Init (R, 'Cancel', cmCancel, bfNormal)));

    SelectNext (False);
    SetData (Data)
  End;
  If DeskTop^.Execview (PD) <> cmOk then Goto LEnd;

  PD^.GetData (Data);
  CFG.Title := Data.Title;
LEnd:
  Dispose (PD, Done);
  DeskTop^.Delete (CtrlDialog);
  CtrlDialog := New (PCtrlDialog, Init (CFG.Title));
  DeskTop^.Insert (CtrlDialog)
End;

Procedure TCtrlApp.SetGeneral;
Type
  TData = Record
    Evaluate : Word;
    Expression : String;
    Save,
    LimitType : Word;
    MaxCountStr,
    MaxTimeStr,
    TimeQuantStr : String[10];
  End;
Label LEnd;
Var
  Data : TData;
  R : TRect;
  PD : PDialog;
  PCB1, PCB2 : PCheckBoxes;
  PRB : PRadioButtons;
  PIL1, PIL2, PIL3, PIL4 : PInputLine;
  E : Integer;
Begin
  Data.Evaluate := Ord (CFG.Evaluate);
  Data.Expression := CFG.Expression;
  Data.Save := Ord (CFG.Save);
  Data.LimitType := CFG.LimitType;
  Str (CFG.MaxCount, Data.MaxCountStr);
  Str (CFG.MaxTime, Data.MaxTimeStr);
  Str (CFG.TimeQuant, Data.TimeQuantStr);

  R.Assign (0, 0, 42, 18);
  PD := New (PDialog, Init (R, 'General settings'));
  With PD^ do Begin
    Options := Options or ofCentered;

    R.Assign (3, 2, 39, 3);
    PCB1 := New (PCheckBoxes, Init (R,
      NewSItem ('~E~valuate expression:',
    Nil)));
    Insert (PCB1);

    R.Assign (3, 3, 39, 4);
    PIL1 := New (PInputLine, Init (R, 255));
    Insert (PIL1);

    R.Assign (3, 5, 39, 6);
    PCB2 := New (PCheckBoxes, Init (R,
      NewSItem ('~S~ave values to file',
    Nil)));
    Insert (PCB2);

    R.Assign (3, 8, 19, 11);
    PRB := New (PRadioButtons, Init (R,
      NewSItem ('no',
      NewSItem ('on count',
      NewSItem ('on time',
    Nil)))));
    Insert (PRB);
    R.Assign (2, 7, 16, 8);
    Insert (New (PLabel, Init (R, 'Values ~l~imit', PRB)));

    R.Assign (21, 8, 39, 9);
    PIL2 := New (PInputLine, Init (R, 10));
    PIL2^.SetValidator (New (PRangeValidator, Init (1, 1000000)));
    Insert (PIL2);
    R.Assign (20, 7, 33, 8);
    Insert (New (PLabel, Init (R, '~C~ount limit', PIL2)));

    R.Assign (21, 10, 39, 11);
    PIL3 := New (PInputLine, Init (R, 10));
    PIL3^.SetValidator (New (PRangeValidator, Init (1, 100000)));
    Insert (PIL3);
    R.Assign (20, 9, 39, 10);
    Insert (New (PLabel, Init (R, '~T~ime limit (secs)', PIL3)));

    R.Assign (3, 13, 39, 14);
    PIL4 := New (PInputLine, Init (R, 10));
    PIL4^.SetValidator (New (PRangeValidator, Init (0, 10000000)));
    Insert (PIL4);
    R.Assign (3, 12, 39, 13);
    Insert (New (PLabel, Init (R, 'Time ~q~uant between two values (ms)', PIL4)));

    R.Assign (10, 15, 20, 17);
    Insert (New (PButton, Init (R, 'O~k~', cmOk, bfDefault)));
    R.Assign (21, 15, 33, 17);
    Insert (New (PButton, Init (R, 'Cancel', cmCancel, bfNormal)));

    SelectNext (False);
    SetData (Data)
  End;
  If DeskTop^.Execview (PD) <> cmOk then Goto LEnd;

  PD^.GetData (Data);
  CFG.Evaluate := Boolean(Data.Evaluate);
  CFG.Expression := Data.Expression;
  CFG.Save := Boolean(Data.Save);
  CFG.LimitType := Data.LimitType;
  Val (Data.MaxCountStr, CFG.MaxCount, E);
  Val (Data.MaxTimeStr, CFG.MaxTime, E);
  Val (Data.TimeQuantStr, CFG.TimeQuant, E);
LEnd:
  Dispose (PD, Done)
End;

Procedure TCtrlApp.SetPort;
Type
  TData = Record
    ComNo : Word;
    BaudRateStr : String[6];
    ComputeTStr,
    SendTStr : String[4]
  End;
Label LEnd;
Var
  Data : TData;
  R : TRect;
  PD : PDialog;
  PRB : PRadioButtons;
  PIL1, PIL2, PIL3 : PInputLine;
  X : LongInt;
  E : Integer;
Begin
  Data.ComNo := CFG.ComNo-1;
  Str (CFG.BaudRate, Data.BaudRateStr);
  Str (CFG.ComputeTime, Data.ComputeTStr);
  Str (CFG.SendCharTime, Data.SendTStr);

  R.Assign (0, 0, 38, 18);
  PD := New (PDialog, Init (R, 'Port settings'));
  With PD^ do Begin
    Options := Options or ofCentered;

    R.Assign (3, 3, 20, 7);
    PRB := New (PRadioButtons, Init (R,
      NewSItem ('Com 1',
      NewSItem ('Com 2',
      NewSItem ('Com 3',
      NewSItem ('Com 4',
    Nil))))));
    X := Ord(Bases[1]<>0) + 2*Ord(Bases[2]<>0) +
         4*Ord(Bases[3]<>0) + 8*Ord(Bases[4]<>0);
    PRB^.EnableMask := X;
    Insert (PRB);
    R.Assign (2, 2, 17, 3);
    Insert (New (PLabel, Init (R, '~P~ort', PRB)));

    R.Assign (3, 9, 35, 10);
    PIL1 := New (PInputLine, Init (R, 6));
    PIL1^.SetValidator (New (PRangeValidator, Init (300, 115200)));
    Insert (PIL1);
    R.Assign (2, 8, 13, 9);
    Insert (New (PLabel, Init (R, '~B~aud rate', PIL1)));

    R.Assign (3, 12, 35, 13);
    PIL2 := New (PInputLine, Init (R, 4));
    PIL2^.SetValidator (New (PRangeValidator, Init (55, 5000)));
    Insert (PIL2);
    R.Assign (2, 11, 30, 12);
    Insert (New (PLabel, Init (R, 'Timeout for ~1~-st char (ms)', PIL2)));

    R.Assign (3, 15, 35, 16);
    PIL3 := New (PInputLine, Init (R, 4));
    PIL3^.SetValidator (New (PRangeValidator, Init (55, 5000)));
    Insert (PIL3);
    R.Assign (2, 14, 31, 15);
    Insert (New (PLabel, Init (R, 'Timeout for ~n~ext chars (ms)', PIL3)));

    R.Assign (21, 3, 35, 5);
    Insert (New (PButton, Init (R, 'O~k~', cmOk, bfDefault)));
    R.Assign (21, 5, 35, 7);
    Insert (New (PButton, Init (R, 'Cancel', cmCancel, bfNormal)));

    SelectNext (False);
    SetData (Data)
  End;
  If DeskTop^.Execview (PD) <> cmOk then Goto LEnd;

  PD^.GetData (Data);
  CFG.ComNo := Data.ComNo+1;
  Val (Data.BaudRateStr, CFG.BaudRate, E);
  Val (Data.ComputeTStr, CFG.ComputeTime, E);
  Val (Data.SendTStr, CFG.SendCharTime, E);
LEnd:
  Dispose (PD, Done)
End;

Procedure TCtrlApp.SetPrnCmd;
Begin
  InputBox ('Set print command', 'Command', CFG.PrnCmd, 255)
End;

Procedure TCtrlApp.About;
Begin
  MessageBox (^C'Serial unit'^M^C'controlling application' +
              ^M^C'(c) 1999 by Alexei A. Frounze', Nil,
               mfInformation+mfOkButton)
End;

Procedure TCtrlApp.CreateDataFile;
Var F : File;
Begin
 {$I-}
 Assign (F, NameData);
 Reset (F, 1);
 If IOResult <> 0 then
   Rewrite (F, 1);
 Close (F)
 {$I+}
End;

Procedure TCtrlApp.OutOfMemory;
Begin
  MessageBox ('Not enough memory available to complete operation.',
    Nil, mfError + mfOkButton)
End;

Procedure TCtrlApp.ViewDataFile;
Var
  PW : PWindow;
Begin
  PW := PWindow(ValidView(New(PFileWindow,Init(NameData))));
  If PW <> Nil then Desktop^.Insert (PW)
End;

Procedure TCtrlApp.ClearDataFile;
Var F : File;
Begin
 {$I-}
 Assign (F, NameData);
 Rewrite (F, 1);
 Close (F)
 {$I+}
End;

Procedure TCtrlApp.OpenComPort;
Var
  BaudRate : Word;
Begin
  BaudRate := 115200 div CFG.BaudRate;
  Base := Bases[CFG.ComNo];
  Port[Base+Control] := $80;
  Port[Base+Hi_Div] := BaudRate shr 8;
  Port[Base+Lo_Div] := BaudRate and $FF;
  Port[Base+Control] := Bits_8+Stops_1+Parity_No;
  Port[Base+Modem] := 0;
  Port[Base+Int_Reg] := 0;
  ComputeLimit := Round (CFG.ComputeTime*18.2E-3);
  SendCharLimit := Round (CFG.SendCharTime*18.2E-3)
End;

Procedure TCtrlApp.CloseComPort;
Begin
{  Port[Base+Int_Reg] := 0;
  Port[Base+Modem] := 0}
End;

Procedure TCtrlApp.SendChar;
Begin
  While Port[Base+Status] and $20 = 0 do;
  Port[Base] := Ord(Value)
End;

Function TCtrlApp.ReceiveChar;
Begin
  If Port[Base+Status] and 1 = 0 then ReceiveChar := False
  Else Begin
    Value :=  Chr(Port[Base]);
    ReceiveChar := True
  End;
End;

Function TCtrlApp.Ticks;
Begin
  Ticks := MemL[Seg0040:$6C]
End;

Function TCtrlApp.Initialize;
Var
  Res : Boolean;
  Stat : Byte;
  C : Char;
  Time,
  LastTime : LongInt;
Label
  LE, LEnd;
Begin
  Res := False;
  CtrlDialog^.Update (4, 0);
  Repeat
    SendChar (NUL);
    LastTime := Ticks;
    Repeat
      C := NUL;
      Stat := Port[Base+Status];
      ReceiveChar (C);
      If KeyMap[sEsc] or KeyMap[sS] then Goto LEnd;
      If (C = ACK) and (Stat and $1E = 0) then Goto LE
      Else Begin
        Time := Ticks;
        If Time >= LastTime + SendCharLimit then Begin
          CtrlDialog^.Update (6, 0);
          Break
        End
      End
    Until False
  Until False;
LE:
  Res := True;
LEnd:
  If Res then CtrlDialog^.Update (4, 0)
  Else CtrlDialog^.Update (7, 0);
  Initialize := Res
End;

Function TCtrlApp.GetValue;
Var
  IOPhase : (phReady, phReceiving, phReceived);
  C : Char;
  VStr : String[4];
  Index : Byte;
  Stat : Byte;
  Time,
  LastTime : LongInt;
  Res : Boolean;
  Err : Integer;
Label
  LInit, LR, LEnd;
Begin
  Goto LR;
LInit:
  Res := Initialize;
  If not Res then Goto LEnd;
LR:
  IOPhase := phReady;
  Repeat
    Stat := Port[Base+Status];
    If Stat and $1E <> 0 then
      Goto LInit;
    If ReceiveChar (C) then Begin
      Case IOPhase of
        phReady :
          Begin
            Goto LInit
          End;
        phReceiving :
          Begin
            Case C of
              '0'..'9','A'..'F' :
                Begin
                  LastTime := Ticks;
                  VStr[Index] := C;
                  VStr[0] := Chr(Index);
                  Inc (Index)
                End;
              Else Begin
                Index := 1;
                CtrlDialog^.Update (2, 0);
                SendChar (NAK);
                LastTime := Ticks
              End
            End;
            If Index > 3 then
              IOPhase := phReceived
          End;
        phReceived :
          Begin
            Goto LInit
          End
      End
    End
    Else Begin
      Case IOPhase of
        phReceived :
          Begin
            SendChar (XOFF);
            IOPhase := phReady;
            Res := True;
            Break
          End;
        phReceiving :
          Begin
            Time := Ticks;
            If (Index = 1) and (Time > LastTime+ComputeLimit) or
              (Index > 1) and (Time > LastTime+SendCharLimit) then Begin
                Index := 1;
                CtrlDialog^.Update (2, 0);
                SendChar (NAK);
                LastTime := Ticks
              End
          End
      End
    End;
    If KeyMap[sEsc] or KeyMap[sS] then Begin
      Res := False;
      Break
    End
    Else If IOPhase = phReady then Begin
      Index := 1;
      SendChar (XON);
      IOPhase := phReceiving;
      LastTime := Ticks
    End
  Until False;
LEnd:
  Val ('$'+VStr, Value, Err);
  GetValue := Res
End;

Procedure TCtrlApp.GetOne;
Var
  Value,
  H, M, S, S100 : Word;
  T : Text;
Begin
  If CFG.Save then Begin
    Assign (T, NameData);
    Append (T)
  End;
  Set_Handler;
  OpenComPort;
  If Initialize then Begin
    If GetValue (Value) then Begin
      CtrlDialog^.Update (1, Value);
      If CFG.Save then Begin
        GetTime (H, M, S, S100);
        WriteLn (T, Value:4, '    ',H:2,':',M:2,':',S:2,'.',S100:3,
                  '    ',EValueStr)
      End;
    End
    Else
      CtrlDialog^.Update (3, 0);
  End
  Else
    CtrlDialog^.Update (7, 0);
  CloseComPort;
  Remove_Handler;
  If CFG.Save then
    Close (T)
End;

Procedure TCtrlApp.GetSeries;
Var
  Value,
  H, M, S, S100 : Word;
  Counter,
  StartTime,
  EndTime,
  LastTime,
  Quant : LongInt;
  T : Text;
Label
  L;
Begin
  If CFG.Save then Begin
    Assign (T, NameData);
    Append (T)
  End;
  Set_Handler;
  OpenComPort;
  If Initialize then Begin
    Counter := 0;
    StartTime := Ticks;
    EndTime := StartTime + Round(CFG.MaxTime*18.2);
    Quant := Round (CFG.TimeQuant*18.2E-3);
    Repeat
      LastTime := Ticks;
      If GetValue (Value) then Begin
        CtrlDialog^.Update (0, Value);
        If CFG.Save then Begin
          GetTime (H, M, S, S100);
          WriteLn (T, Value:4, '    ',H:2,':',M:2,':',S:2,'.',S100:3,
                      '    ',EValueStr)
        End;
        Inc (Counter)
      End
      Else Begin
        CtrlDialog^.Update (3, 0);
        Break
      End;
      If (CFG.LimitType = 1) and (Counter = CFG.MaxCount) or
         (CFG.LimitType = 2) and (Ticks >= EndTime) then Begin
L:
        CtrlDialog^.Update (1, Value);
        Break
      End;
      While Ticks < LastTime+Quant do
        If KeyMap[sEsc] or KeyMap[sS] then Goto L
    Until False
  End
  Else
    CtrlDialog^.Update (7, 0);
  CloseComPort;
  Remove_Handler;
  If CFG.Save then
    Close (T)
End;

Procedure TCtrlApp.Print;
Begin
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneDOSMem;
  SwapVectors;
  Exec (GetEnv('COMSPEC'), '/C '+CFG.PrnCmd);
  SwapVectors;
  InitDOSMem;
  InitVideo;
  InitEvents;
  InitSysError;
  Redraw;
End;

Var
  CtrlApp : TCtrlApp;

Begin
  CtrlApp.Init;
  CtrlApp.Run;
  CtrlApp.Done
End.
